//if($DamageType::Chain_Lightning $= "") addDamageType("Chain_Lightning", '<bitmap:Add-Ons/Server_CastleDefense/CI_Chain_Lightning> %1', '%2 <bitmap:Add-Ons/Server_CastleDefense/CI_Chain_Lightning> %1', 1, 1);
if($DamageType::Chain_Lightning $= "") addDamageType("Chain_Lightning", '%1 chain lightninged himself!', '%2 chain lightninged %1!', 1, 1);
if($DamageType::Fireball $= "") addDamageType("Fireball", '<bitmap:Add-Ons/Server_CastleDefense/CI_Fireball> %1', '%2 <bitmap:Add-Ons/Server_CastleDefense/CI_Fireball> %1', 1, 1);
if($DamageType::ZombieHorde $= "") addDamageType("ZombieHorde", 'Horde <bitmap:base/client/ui/ci/skull> %1', '%2\'s Horde <bitmap:base/client/ui/ci/skull> %1', 1, 1);
if($DamageType::NoMessage $= "") addDamageType("NoMessage", '', '', 1, 1);

function doNothing() { }
function mEulerToAxis(%euler)
{
	 %euler = VectorScale(%euler, 0.0174533);
	 %matrix = MatrixCreateFromEuler(%euler);
	 return getWords(%matrix, 3, 6);
}

function SimGroup::updateAll(%this)
{
	if(%this.getName() !$= "CastleDefense") return;
	%spawnedBots = 0;
	%count = %this.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = %this.getObject(%i);
		if((%obj.getType() & $Typemasks::PlayerObjectType) && %obj.attacker)
			%spawnedBots++;
	}
	%this.spawnedBots = %spawnedBots;
	for(%i=0;%i<ClientGroup.getCount();%i++)
		%this.updateClient(ClientGroup.getObject(%i));
	%this.spawnedBots = "";
}

function SimGroup::updateClient(%this, %cl)
{
	if(%this.getName() !$= "CastleDefense") return;
	if(%this.spawnedBots $= "")
	{
		%spawnedBots = 0;
		%count = %this.getCount();
		for(%i=0;%i<%count;%i++)
		{
			%obj = %this.getObject(%i);
			if(%obj.getType() & $Typemasks::PlayerObjectType && %obj.attacker)
				%spawnedBots++;
		}
		%this.spawnedBots = %spawnedBots;
		%clear = 1;
	}
	if(isObject(%pl = %cl.player))
	{
		if($Builder == %cl && %pl.placingBot !$= "")
		{
			switch$(%pl.placingBot)
			{
				case "Archer": %text = "Your basic ranged offense unit.";
				case "Knight": %text = "Heavy ranged offense unit. Gives nearby units a physical defense buff.";
				case "Mason": %text = "Repairs damage to nearby walls, including the Castle.";
				case "Medic": %text = "Heals nearby units over time.";
			}
			%cl.bottomPrint("\c6Placing the "@%pl.placingBot@(%text!$=""?" - "@%text:".")@"<br>\c6Current cost: "@CD_UnitCost(%pl.placingBot, 0)@"   Current score: "@CastleDefense.score, 600, 1);
		}
		else	%cl.bottomPrint("\c1Castle Stats: \c3Score: \c2"@CastleDefense.score@"   \c3Health: \c2"@mFloatLength(%this.health, 0)@"\c3/\c2"@mFloatLength(%this.maxHealth, 0)@"   \c3Enemies Left: \c2"@%this.spawnedBots@" ("@%this.enemiesLeft-%this.spawnedBots@")"
			@"<br>\c1Your Stats: \c3Health: \c2"@mFloatLength((1-%pl.getDamagePercent())*100,1)@"%", 600, 1);
	}
	else	%cl.bottomPrint("\c1Castle Stats: \c3Score: \c2"@CastleDefense.score@"   \c3Health: \c2"@mFloatLength(%this.health, 0)@"\c3/\c2"@mFloatLength(%this.maxHealth, 0)@"   \c3Enemies Left: \c2"@%this.spawnedBots@" ("@%this.enemiesLeft-%this.spawnedBots@")", 600, 1);
	if(%clear) %this.spawnedBots = "";
}

package CastleDefense
{
	function Armor::damage(%data, %this, %proj, %pos, %damage, %damageType)
	{
		if(!isObject(CastleDefense)) { Parent::damage(%data, %this, %proj, %pos, %damage, %damageType); return; }
		if(%proj.getClassName() $= "GameConnection" || %proj.class $= "AIConnectionSO") %cl = %proj;
		else %cl = %proj.client;
		//if(%this.attacker) %damage *= (5 / CastleDefense.level);
		if(%damage > 0 && isEventPending(%this.knightAura))
		{
			%reduce = 0;
			if(%damageType == $DamageType::ArrowDirect) %reduce = 1;
			if(%damageType == $DamageType::SpearDirect) %reduce = 1;
			if(%damageType == $DamageType::SpearRadius) %reduce = 1;
			if(%damageType == $DamageType::Sword) %reduce = 1;
			if(%reduce) %damage *= 0.3;
		}
		if(%this.attacker && %this.logAttacks)
		{
			if(%this.damageFrom[%cl] $= "")
				%this.damager[-1+%this.damagers++] = %cl;
			%this.damageFrom[%cl] += %damage;
		}
		if(%this.attacker && %this.getMountedObject(0).logAttacks)
		{
			if(%this.getMountedObject(0).damageFrom[%cl] $= "")
				%this.getMountedObject(0).damager[-1+%this.getMountedObject(0).damagers++] = %cl;
			%this.getMountedObject(0).damageFrom[%cl] += %damage;
		}
		if(!%this.attacker && %damageType == $DamageType::SpearDirect)
			%damage *= 4;
		%unreducable[$DamageType::Fireball] = 1;
		%unreducable[$DamageType::Chain_Lightning] = 1;
		if(%damage > 0 && %this.damageReduction != 0 && !%unreducable[%damageType])
		{ %damage -= %this.damageReduction; if(%damage <= 0) return; }
		if(%this.damageMult !$= "") %damage *= %this.damageMult;
		if(%cl.damageMult !$= "") %damage *= %cl.damageMult;
		if(!%this.attacker) %damage /= (%this.getClassName() $= "Player" ? 1 : (%cl.unreducable | %unreducable[%damageType] ? 3 : 10));
		else %damage /= (%this.getClassName() $= "AIPlayer" ? 1 : (%cl.unreducable | %unreducable[%damageType] ? 1 : 2.5));
		if(%damageType == $DamageType::Fireball) %this.calcifiedDamage += %damage / 2;
		if(%damageType == $DamageType::Chain_Lightning) %this.calcifiedDamage += %damage;
		Parent::damage(%data, %this, %proj, %pos, %damage, %damageType); if(%this.getClassName() $= "Player" && isObject(%cl = %this.client)) CastleDefense.updateClient(%cl);
		if(isObject(%name = %this.shapeName))
		{
			%damage = 1 - %this.getDamagePercent();
			%name.setShapeName(mFloatLength(%damage * 100, 0));
			if(%damage >= 0.5) %name.setShapeNameColor(((1 - %damage) * 2)@" 1 0");
			else %name.setShapeNameColor("1 "@(%damage * 2)@" 0");
		}
		if(%this.getState() $= "DEAD" && %damageType == $DamageType::ZombieHorde)
			%this.schedule(2000, "CreateZombie", %cl);
	}
	
	function minigameCanDamage(%a, %b)
	{
		if(!isObject(CastleDefense)) return Parent::minigameCanDamage(%a, %b);
		if(CastleDefense.health <= 0) return 0;
		switch$(%a.getClassName())
		{
			case "ScriptObject": %clA = %a;
			case "AIPlayer": %clA = %a.client;
			case "GameConnection": %clA = %a;
			case "Player": %clA = %a.client;
			case "Projectile": %clA = %a.client;
		}
		switch$(%b.getClassName())
		{
			case "ScriptObject": %clB = %b;
			case "AIPlayer": %clB = %b.client;
			case "GameConnection": %clB = %b;
			case "Player": %clB = %b.client;
			case "Projectile": %clB = %b.client;
		}
		if(%clA.attacker ^ %clB.attacker ^ %clA.player.confused) return 1; return 0;
	}
	
	function GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea)
	{
		if(!isObject(CastleDefense)) Parent::onDeath(%cl, %col, %killer, %damageType, %damageArea);
		else
		{
			if(%cl.botName !$= "")
			{
				%name = %cl.botName;
				if(!%cl.alwaysNamed)
				{
					%bots++;
					if(%damageType == $DamageType::Fireball) %bots++;
					if(%damageType == $DamageType::Chain_Lightning) %bots++;
				}
				%cl.player.client = ""; %removePlayer = 1;
				if(%damageType == $DamageType::Fireball) %killer.fireballBotsKilled++;
				if(%damageType == $DamageType::Chain_Lightning) %killer.lightningBotsKilled++;
				CastleDefense.idleClient[-1+CastleDefense.idleClients++] = %cl;
			}
			else %name = %cl.name;
			if(%killer.botName !$= "") { %other = %killer.botName; %bots++; } else %other = %killer.name;
			if(!isObject(%killer) || %cl == %killer) %msg = $DeathMessage_Suicide[%damageType];
			else %msg = $DeathMessage_Murder[%damageType];
			if(%bots < 2) messageAll('', strReplace(strReplace(getTaggedString(%msg), "%1", %name), "%2", %other));
			if(%cl.attacker)
			{
				if(%cl.score $= "") %cl.score = 12500;
				CastleDefense.score += %cl.score;
				if(%cl.class $= "AIConnectionSO")
				{
					if(%cl.player.type !$= "Zombie")
					{
						CastleDefense.enemiesLeft--;
						if(!CastleDefense.wavesPending)
						{
							for(%i=0;%i<CastleDefense.getCount();%i++)
							{
								%obj = CastleDefense.getObject(%i);
								if(%obj.getClassName() !$= "AIPlayer") continue;
								if(%obj.getState() $= "DEAD" || !%obj.attacker) continue;
								if(%obj.type $= "Zombie") continue;
								%attackers++;
							}
							if(%attackers == 0)
							{
								messageAll('MsgAdminForce', CastleDefense.victoryText $= "" ? "\c6Wave "@CastleDefense.level@" complete!" : CastleDefense.victoryText);
								CastleDefense.victoryText = ""; %level = CastleDefense.level++;
								messageAll('MsgAdminForce', "\c6You have thirty seconds to prepare for Wave "@%level@"!");
								for(%i=0;%i<CastleDefense.wait;%i++) cancel(CastleDefense.wait[%i]); CastleDefense.wait = 0;
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(10000, 0, "messageAll", 'MsgAdminForce', "\c6You have twenty seconds left to prepare for Wave "@%level@"!");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(20000, 0, "messageAll", 'MsgAdminForce', "\c6You have ten seconds left to prepare for Wave "@%level@"!");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(25000, 0, "messageAll", 'MsgAdminForce', "\c6Five...");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(26000, 0, "messageAll", 'MsgAdminForce', "\c6four...");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(27000, 0, "messageAll", 'MsgAdminForce', "\c6three...");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(28000, 0, "messageAll", 'MsgAdminForce', "\c6two...");
								CastleDefense.wait[-1+CastleDefense.wait++] = schedule(29000, 0, "messageAll", 'MsgAdminForce', "\c6one...");
								CastleDefense.wait[-1+CastleDefense.wait++] = CastleDefense.schedule(30000, "sendHorde");
							}
						}
					}
				}
				CastleDefense.updateAll();
			}
			else
			{
				CastleDefense.score += mFloor(CD_UnitCost(%cl.player.type, -1) / 4);
				CastleDefense.updateAll();
			}
			Parent::onDeath(%cl, %col, %killer, $DamageType::NoMessage, %damageArea);
			if(%removePlayer) %cl.player = "";
		}
	}
	
	function GameConnection::onClientLeaveGame(%cl)
	{
		Parent::onClientLeaveGame(%cl);
		$Count = ClientGroup.getCount();
		if($Builder == %cl)
		{
			messageAll('MsgAdminForce', "\c3The Buyer left his fort mid-round!");
			messageAll('MsgAdminForce', "\c3Starting a new game...");
			if(CastleDefense.level != 1)
			{
				$CastleDefense::TotalWaves[%cl.bl_id] += CastleDefense.level - 1;
				$CastleDefense::TotalGames[%cl.bl_id]++;
				export("$CastleDefense*", "config/server/CastleDefense.cs");
			}
			CastleDefense.health = 0;
			schedule(5000, 0, "newCastleDefenseGame");
		}
	}
	
	function GameConnection::createPlayer(%cl, %trans)
	{
		if(isObject(CastleDefense)) if(!%cl.attacker) %trans = (getRandom(-15, 15) / 10) SPC (getRandom(-15, 15) / 10)@" 8.025 1 0 0 0";
		else
		{
			while(%pos $= "" || %flag)
			{
				%flag = 0; %pos = "0 0"; while(vectorDist(%pos, "0 0") <= 60) %pos = getRandom(49, -50) * 2 + 1 SPC getRandom(49, -50) * 2 + 1;
				initContainerBoxSearch(%pos@" 4", "1.95 1.95 3.95", $Typemasks::fxBrickAlwaysObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType);
				while(isObject(%obj = containerSearchNext()))
				{
					if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType) { if(%obj.isPlanted() && !%obj.isDead()) %flag = 1; }
					else if(%obj.getType() & $Typemasks::PlayerObjectType)
					{
						%loc = %obj.getHackPosition();
						%x = mFloatLength((getWord(%loc, 0) - 1) / 2, 0) * 2 + 1;
						%y = mFloatLength((getWord(%loc, 1) - 1) / 2, 0) * 2 + 1;
						%z = mFloatLength((getWord(%loc, 2) - 1) / 2, 0) * 2 + 2;
						%loc = %x SPC %y SPC %z;
						if(vectorDist(%loc, vectorAdd(%pos, "0 0 -2")) <= 0.05 || vectorDist(%loc, %pos) <= 0.05 || vectorDist(%loc, vectorAdd(%pos, "0 0 2")) <= 0.05) %flag = 1;
					}
					else %flag = 1;
				}
			}
			%diff = vectorSub("0 0 "@getWord(%pos, 2), %pos);
			%ang = mAtan(getWord(%diff, 0), getWord(%diff, 1));
			%trans = %pos@" 2.025 0 0 1 "@%ang;
		}
		Parent::createPlayer(%cl, %trans);
		if(isObject(CastleDefense) && isObject(%pl = %cl.player))
		{
			if(%cl.attacker) { %pl.attacker = 1; CastleDefense.add(%pl); }
			%pl.changeDatablock(PlayerNoJet); %pl.clearTools(); %pl.isBuilding = 1;
			if(!%cl.attacker)
			{
				%pl.tool0 = SwordItem.getID(); messageClient(%cl, 'MsgItemPickup', '', 0, SwordItem.getID(), 1);
				%pl.tool1 = BowItem.getID(); messageClient(%cl, 'MsgItemPickup', '', 1, BowItem.getID(), 1);
				%pl.tool2 = SpearItem.getID(); messageClient(%cl, 'MsgItemPickup', '', 2, SpearItem.getID(), 1);
			}
			%pl.setShapeNameDistance(0);
		}
	}
	
	function Player::activateStuff(%pl, %a, %b, %c, %d, %e, %f, %g)
	{
		if(!%pl.attacker)
		{
			%los = %pl.getEyeVector(); %eye = %pl.getEyePoint();
			%mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType | $Typemasks::VehicleObjectType;
			%ray = containerRaycast(%eye, vectorAdd(%eye, vectorScale(%los, 12)), %mask, %pl);
			if(isObject(%obj = firstWord(%ray)) && %obj.isCastlePart)
				%pl.setTransform((getRandom(-15, 15) / 10) SPC (getRandom(-15, 15) / 10)@" 8.025 "@getWords(%pl.getTransform(), 3, 6));
		}
		Parent::activateStuff(%pl, %a, %b, %c, %d, %e, %f, %g);
	}
	
	function Player::delete(%pl)
	{
		if(isObject(%cube = %pl.targetCube)) %cube.delete();
		if(isObject(%name = %pl.shapeName)) %name.delete();
		if(%pl.getClassName() $= "AIPlayer" && isObject(%cl = %pl.client)) %cl.delete();
		Parent::delete(%pl);
	}
	function TargetCubeSO::delete(%cube) { for(%i=0;%i<12;%i++) { if(!isObject(%shape = %cube.shape[%i])) continue; %shape.delete(); } Parent::delete(%cube); }
	
	function ArrowProjectile::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel)
	{
		Parent::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel);
		if(%proj.client.attacker)
			if(%hit.isCastlePart && CastleDefense.health > 0)
			{
				CastleDefense.health -= 3.0;
				if(CastleDefense.health <= 0)
				{
					CastleDefense.health = 0;
					for(%i=CastleDefense.getCount()-1;%i>=0;%i--)
						if((%obj = CastleDefense.getObject(%i)).isCastlePart || %obj.maxHealth !$= "") %obj.delete();
					messageAll('MsgClearBricks', "<color:FF0000><font:impact:40>THE CASTLE HAS FALLEN!");
					$CastleDefense::TotalWaves[$Builder.bl_id] += CastleDefense.level - 1;
					$CastleDefense::TotalGames[$Builder.bl_id]++;
					export("$CastleDefense*", "config/server/CastleDefense.cs");
					schedule(5000, 0, "newCastleDefenseGame");
				}
				if(!isEventPending(CastleDefense.updateSched))
					CastleDefense.updateSched = CastleDefense.schedule(200, "updateAll");
			}
			else if(%hit.maxHealth != 0 && !%proj.hasHitWall)
			{
				%proj.hasHitWall = 1;
				%hit.health -= 0.5;
				if(%hit.health <= 0)
				{ %hit.schedule(0, "delete"); return; }
				%col = %hit.health / (%hit.maxHealth * 2);
				%hit.setNodeColor("ALL", %hit.color = %col SPC %col SPC %col@" 1");
			}
	}
	
	function SpearProjectile::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel)
	{
		Parent::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel);
		if(%proj.client.attacker && CastleDefense.health > 0)
			if(%hit.isCastlePart)
			{
				CastleDefense.health -= 10;
				if(CastleDefense.health <= 0)
				{
					CastleDefense.health = 0;
					for(%i=CastleDefense.getCount()-1;%i>=0;%i--)
						if((%obj = CastleDefense.getObject(%i)).isCastlePart || %obj.maxHealth !$= "") %obj.delete();
					messageAll('MsgClearBricks', "<color:FF0000><font:impact:40>THE CASTLE HAS FALLEN!");
					$CastleDefense::TotalWaves[$Builder.bl_id] += CastleDefense.level - 1;
					$CastleDefense::TotalGames[$Builder.bl_id]++;
					export("$CastleDefense*", "config/server/CastleDefense.cs");
					schedule(5000, 0, "newCastleDefenseGame");
				}
				if(!isEventPending(CastleDefense.updateSched))
					CastleDefense.updateSched = CastleDefense.schedule(200, "updateAll");
			}
			else if(%hit.maxHealth != 0)
			{
				%hit.health -= 5;
				if(%hit.health <= 0)
				{ %hit.schedule(0, "delete"); return; }
				%col = %hit.health / (%hit.maxHealth * 2);
				%hit.setNodeColor("ALL", %hit.color = %col SPC %col SPC %col@" 1");
			}
	}
	
	function SwordProjectile::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel)
	{
		Parent::onCollision(%data, %proj, %hit, %a, %pos, %normal, %vel);
		if(%proj.client.attacker && CastleDefense.health > 0)
			if(%hit.isCastlePart)
			{
				CastleDefense.health -= 3.5;
				if(CastleDefense.health <= 0)
				{
					CastleDefense.health = 0;
					for(%i=CastleDefense.getCount()-1;%i>=0;%i--)
						if((%obj = CastleDefense.getObject(%i)).isCastlePart || %obj.maxHealth !$= "") %obj.delete();
					messageAll('MsgClearBricks', "<color:FF0000><font:impact:40>THE CASTLE HAS FALLEN!");
					$CastleDefense::TotalWaves[$Builder.bl_id] += CastleDefense.level - 1;
					$CastleDefense::TotalGames[$Builder.bl_id]++;
					export("$CastleDefense*", "config/server/CastleDefense.cs");
					schedule(5000, 0, "newCastleDefenseGame");
				}
				if(!isEventPending(CastleDefense.updateSched))
					CastleDefense.updateSched = CastleDefense.schedule(200, "updateAll");
			}
			else if(%hit.maxHealth != 0)
			{
				%hit.health -= 1;
				if(%hit.health <= 0)
				{ %hit.schedule(0, "delete"); return; }
				%col = %hit.health / (%hit.maxHealth * 2);
				%hit.setNodeColor("ALL", %hit.color = %col SPC %col SPC %col@" 1");
			}
	}
};
activatePackage("CastleDefense");

function AIConnectionSO::onDeath(%cl, %col, %killer, %damageType, %damageArea)
{
	GameConnection::onDeath(%cl, %col, %killer, %damageType, %damageArea);
}

function servercmdTotalAIs(%cl)
{
	for(%i=0;%i<CastleDefense.getCount();%i++) if((%obj = CastleDefense.getObject(%i)).getClassName() $= "AIPlayer" && isObject(%obj.client)) %count++;
	%cl.chatMessage("\c3Total AI clients over the server lifespan: "@$Clients+0);
	%cl.chatMessage("\c3Total AI clients + idle AI clients: "@%count+CastleDefense.idleClients);
	%cl.chatMessage("\c3Total AI clients right now: "@%count+0);
}

function servercmdMyAvg(%cl)
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
		if((%this = ClientGroup.getObject(%i)).hasSpawnedOnce) if(!%this.attacker) %list[-1+%list++] = %this;
	for(%i=0;%i<%list;%i++)
	{
		%this = %list[%i]; %blid = %this.bl_id;
		if($CastleDefense::TotalGames[%blid] <= 0)
			%avg[%i] = 10;   //Default to ten rounds per game if they've never played a game
		else	%avg[%i] = mFloatLength($CastleDefense::TotalWaves[%blid] / $CastleDefense::TotalGames[%blid], 2);
		%sum += %avg[%i];
	}
	if($CastleDefense::TotalGames[%cl.bl_id] <= 0) %myAvg = 10;
	else %myAvg = mFloatLength($CastleDefense::TotalWaves[%cl.bl_id] / $CastleDefense::TotalGames[%cl.bl_id], 2);
	%myChance = (%sum == 0 ? 1 / %list : %myAvg / %sum); %percent = mFloatLength(%myChance * 100, 3);
	%cl.chatMessage("\c3Your average is currently \c2"@%myAvg@"\c3 waves per game."); if(%cl.attacker) %cl.chatMessage("\c3You currently have a \c20.000%%\c3 chance of being chosen as the Builder next round.");
	else %cl.chatMessage("\c3You currently have a"@(getSubStr(%percent,0,1)$="8"?"n":"")@" \c2"@%percent@"%%\c3 chance of being chosen as the Builder next round.");
}

function StaticShape::resetCubeColor(%cube)
{ %cube.setNodeColor("ALL", %cube.color); }

function createCube(%pos, %scale, %color) { (%cube = new StaticShape() { datablock = CastleDefenseCube_Col1; position = %pos; scale = %scale; }).setNodeColor("ALL", %color); return %cube; }

function newCastleDefenseGame()
{
	for(%i=0;%i<ClientGroup.getCount();%i++)
		if((%cl = ClientGroup.getObject(%i)).hasSpawnedOnce)
		{
			if(!%cl.attacker) %list[-1+%list++] = %cl;
			if(isObject(%cl.zombieGroup))
				%cl.totalZombies = getMin(%cl.zombieGroup.getCount(), 5);
		}
	CastleDefense.queued = 0;
	if(%list == 0) { schedule(200, 0, "newCastleDefenseGame"); return; }
	buildArena(); CastleDefense.updateAll();
	for(%i=0;%i<ClientGroup.getCount();%i++)
		if((%cl = ClientGroup.getObject(%i)).hasSpawnedOnce) %cl.instantRespawn();
	for(%i=0;%i<%list;%i++)
	{
		%cl = %list[%i]; %blid = %cl.bl_id;
		if($CastleDefense::TotalGames[%blid] <= 0)
			%avg[%i] = 10;   //Default to ten rounds per game if they've never played a game
		else	%avg[%i] = mFloatLength($CastleDefense::TotalWaves[%blid] / $CastleDefense::TotalGames[%blid], 2);
		%sum += %avg[%i];
	}
	for(%i=0;%i<ClientGroup.getCount();%i++)
	{
		%cl = ClientGroup.getObject(%i);
		if(%cl.totalZombies != 0)
		{
			for(%i=0;%i<%cl.totalZombies;%i++)
			{
				%ang = %i / %cl.totalZombies * (2 * $PI);
				%pos = vectorScale(mSin(%ang) SPC mCos(%ang), -5);
				CreateZombieAtTransform(vectorAdd(%cl.player.getPosition(), %pos)@" 0 0 1 "@%ang, %cl);
			}
		}
	}
	if(%sum == 0) { $Builder = %list[getRandom(0, %list - 1)]; %avg0 = 0; %sel = 0; }
	else
	{
		%rand = getRandom(0, %sum * 100 - 1) / 100;
		for(%i=0;%i<%list;%i++)
		{
			%rand -= %avg[%i];
			if(%rand < 0) { %sel = %i; break; }
		}
		$Builder = %list[%sel];
	}
	messageClient($Builder, 'MsgSetInvData', '', 0, brickArcherIconData.getID());
	messageClient($Builder, 'MsgSetInvData', '', 1, brickMasonIconData.getID());
	messageClient($Builder, 'MsgSetInvData', '', 2, brickMedicIconData.getID());
	messageClient($Builder, 'MsgSetInvData', '', 3, 0);
	messageClient($Builder, 'MsgSetInvData', '', 4, 0);
	messageClient($Builder, 'MsgSetInvData', '', 5, 0);
	messageClient($Builder, 'MsgSetInvData', '', 6, 0);
	messageClient($Builder, 'MsgSetInvData', '', 7, 0);
	messageClient($Builder, 'MsgSetInvData', '', 8, 0);
	messageClient($Builder, 'MsgSetInvData', '', 9, brickBuildingIconData.getID());
	messageAll('MsgAdminForce', "\c3The Builder this round is \c2"@$Builder.name@"\c3! (Average waves per game: "@($CastleDefense::TotalGames[$Builder.bl_id]==0?"N/A":%avg[%sel])@")");
}

function buildArena()
{
	if(isObject(CastleDefense))
	{
		for(%i=0;%i<CastleDefense.wait;%i++) cancel(CastleDefense.wait[%i]);
		for(%i=0;%i<CastleDefense.idleClients;%i++) %idle[%i] = CastleDefense.idleClient[%i];
		%idles = CastleDefense.idleClients;
		for(%i=0;%i<CastleDefense.getCount();%i++)
		{
			if((%obj = CastleDefense.getObject(%i)).getClassName() $= "AIPlayer" && isObject(%cl = %obj.client))
			{ %cl.player = ""; %obj.client = ""; %idle[-1+%idles++] = %cl; }
		}
		CastleDefense.delete();
	}
	new SimGroup(CastleDefense); CastleDefense.idleClients = %idles;
	for(%i=0;%i<%idles;%i++) CastleDefense.idleClient[%i] = %idle[%i];
	CastleDefense.add(createCube("0 0 1", "100 100 1", "0.05 0.45 0.15 1"));
	CastleDefense.add(%cube = createCube("0 0 5", "6 6 3", "0.5 0.5 0.5 1")); %cube.isCastlePart = 1;
	CastleDefense.add(%cube = createCube("6 6 6", "2 2 4", "0.3 0.3 0.3 1")); %cube.isCastlePart = 1;
	CastleDefense.add(%cube = createCube("-6 6 6", "2 2 4", "0.3 0.3 0.3 1")); %cube.isCastlePart = 1;
	CastleDefense.add(%cube = createCube("-6 -6 6", "2 2 4", "0.3 0.3 0.3 1")); %cube.isCastlePart = 1;
	CastleDefense.add(%cube = createCube("6 -6 6", "2 2 4", "0.3 0.3 0.3 1")); %cube.isCastlePart = 1;
	CastleDefense.add(%cube = createCube("0 0 10", "2 2 2", "0.5 0.5 0.5 1")); %cube.hideNode("ALL"); %cube.setDatablock(CastleDefenseCube_Col0);
	CastleDefense.add(createCube("0 103 1", "100 3 1", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("103 0 1", "3 106 1", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("0 -103 1", "100 3 1", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("-103 0 1", "3 106 1", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("0 108 20", "110 2 20", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("108 0 20", "2 106 20", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("0 -108 20", "110 2 20", "0.2 0.2 0.2 1"));
	CastleDefense.add(createCube("-108 0 20", "2 106 20", "0.2 0.2 0.2 1"));
	%trees = getRandom(50, 150); //%trees = 0;
	for(%i=0;%i<%trees;%i++)
	{
		%pos = ""; while(vectorDist(%pos, "0 0") <= 25) %pos = getRandom(49, -50) * 2 + 1 SPC getRandom(49, -50) * 2 + 1;
		%wide = !getRandom(0, 3); if(%wide) %trunk = getRandom(3, 6); else %trunk = getRandom(2, 4);
		CastleDefense.add(createCube(%pos SPC (%trunk + 2), "1 1 "@%trunk, "0.4 0.2 0 1"));
		if(%wide) %height = getRandom(3, 6); else %height = getRandom(2, 4);
		CastleDefense.add(createCube(%pos SPC (%height + %trunk * 2 + 2), (%wide?"5 5 "@%height:"3 3 "@%height), "0 0.5 0 1"));
	}
	CastleDefense.score = 1500; CastleDefense.level = 1; CastleDefense.health = 100; CastleDefense.maxHealth = 100; CastleDefense.enemiesLeft = 0; CastleDefense.wait = 0;
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(30000, 0, "messageAll", 'MsgAdminForce', "\c6You have one hundred twenty seconds to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(60000, 0, "messageAll", 'MsgAdminForce', "\c6You have ninety seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(90000, 0, "messageAll", 'MsgAdminForce', "\c6You have sixty seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(100000, 0, "messageAll", 'MsgAdminForce', "\c6You have fifty seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(110000, 0, "messageAll", 'MsgAdminForce', "\c6You have forty seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(120000, 0, "messageAll", 'MsgAdminForce', "\c6You have thirty seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(130000, 0, "messageAll", 'MsgAdminForce', "\c6You have twenty seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(140000, 0, "messageAll", 'MsgAdminForce', "\c6You have ten seconds left to prepare for Wave 1!");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(145000, 0, "messageAll", 'MsgAdminForce', "\c6Five...");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(146000, 0, "messageAll", 'MsgAdminForce', "\c6four...");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(147000, 0, "messageAll", 'MsgAdminForce', "\c6three...");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(148000, 0, "messageAll", 'MsgAdminForce', "\c6two...");
	CastleDefense.wait[-1+CastleDefense.wait++] = schedule(149000, 0, "messageAll", 'MsgAdminForce', "\c6one...");
	CastleDefense.wait[-1+CastleDefense.wait++] = CastleDefense.schedule(150000, "sendHorde");
}

function SimGroup::sendWave(%this, %type, %count, %final)
{
	if(%final) %this.wavesPending = 0;
	for(%i=0;%i<%count;%i++)
	{
		%noSpawn = 0; %pos = "0 0"; while(vectorDist(%pos, "0 0") <= 60)
			%pos = getRandom(49, -50) * 2 + 1 SPC getRandom(49, -50) * 2 + 1;
		initContainerBoxSearch(%pos@" 4", "1.95 1.95 3.95", $Typemasks::fxBrickAlwaysObjectType | $Typemasks::PlayerObjectType | $Typemasks::StaticShapeObjectType | $Typemasks::TerrainObjectType);
		while(isObject(%obj = containerSearchNext()))
		{
			if(%obj.getType() & $Typemasks::fxBrickAlwaysObjectType) { if(%obj.isPlanted() && !%obj.isDead()) %noSpawn = 1; }
			else if(%obj.getClassName() $= "Player") { } else if(%obj.getClassName() $= "AIPlayer")
			{
				%loc = %obj.getHackPosition();
				%x = mFloatLength((getWord(%loc, 0) - 1) / 2, 0) * 2 + 1;
				%y = mFloatLength((getWord(%loc, 1) - 1) / 2, 0) * 2 + 1;
				%z = mFloatLength((getWord(%loc, 2) - 1) / 2, 0) * 2 + 2;
				%loc = %x SPC %y SPC %z;
				if(vectorDist(%loc, vectorAdd(%pos, "0 0 -2")) <= 0.05 || vectorDist(%loc, %pos) <= 0.05 || vectorDist(%loc, vectorAdd(%pos, "0 0 2")) <= 0.05) %noSpawn = 1;
			}
			else %noSpawn = 1;
		}
		if(%noSpawn) %count++;
		else { createAttacker(%pos@" 2.025", %type); }
	}
}

//function getValidPoint(){while(vectorDist(%pos, "0 0") <= 60)%pos = getRandom(49, -50) * 2 + 1 SPC getRandom(49, -50) * 2 + 1;return %pos;}

function createAttacker(%pos, %type)
{
	%count = CastleDefense.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if((%obj.getType() & $Typemasks::PlayerObjectType) && %obj.attacker)
			%spawnedBots++;
	}
	if(%spawnedBots >= 60)
	{
		CastleDefense.queue[-1+CastleDefense.queued++] = %pos TAB %type;
		if(!isEventPending(CastleDefense.dequeueLoop))
			CastleDefense.dequeueLoop = schedule(16, 0, "dequeueAttacker");
		return;
	}
	%bot = new AIPlayer() { attacker = 1; datablock = PlayerNoJet; type = %type; position = "0 0 -999"; };
	%diff = vectorSub("0 0 "@getWord(%pos, 2), %pos);
	%ang = mAtan(getWord(%diff, 0), getWord(%diff, 1));
	%bot.setTransform(%pos@" 0 0 1 "@%ang);
	%skin = mSqrt(getRandom(16, 64) / 100); %skin = %skin SPC (%skin - 0.2) SPC (%skin - 0.4);
	%bot.setNodeColor("headskin", %skin@" 1.0");
	%bot.setNodeColor("lhand", %skin@" 1.0");
	%bot.setNodeColor("rhand", %skin@" 1.0");
	switch$(%type)
	{
		case "Archer":
			%bot.unhideNode("scoutHat");
			%bot.unhideNode("quiver");
			%bot.setNodeColor("scoutHat", "0.6 0.2 0.0 1.0");
			%bot.setNodeColor("chest", "0.5 0.1 0.1 1.0");
			%bot.setNodeColor("quiver", "0.5 0.3 0.1 1.0");
			%bot.setNodeColor("larm", "0.4 0.0 0.0 1.0");
			%bot.setNodeColor("rarm", "0.4 0.0 0.0 1.0");
			%bot.setNodeColor("lhand", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("rhand", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("pants", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("lshoe", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("rshoe", "0.2 0.2 0.2 1.0");
			%bot.setDecalName("Archer");
			%bot.playThread(0, "headUp");
			%name = "Enemy Archer"; %score = 35;
			%bot.AtkArcherLoop();
		case "Basic":
			%bot.unhideNode("pointyHelmet");
			%bot.unhideNode("shoulderPads");
			%bot.setNodeColor("pointyHelmet", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("shoulderPads", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("chest", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("larm", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("rarm", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("pants", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("lshoe", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("rshoe", "0.3 0.3 0.3 1.0");
			%bot.setDecalName("Knight");
			%bot.playThread(0, "headUp");
			%name = "Enemy Swordsman"; %score = 2;
			%bot.AtkBasicLoop();
		case "Knight":
			if(CastleDefense.level <= 10) %named = 1;
			%unreducable = 1;
			%bot.logAttacks = 1;
			%bot.damageMult = 0.25;
			%bot.damageReduction = 25;
			%bot.unhideNode("pointyHelmet");
			%bot.unhideNode("shoulderPads");
			%bot.unhideNode("armor");
			%bot.setNodeColor("pointyHelmet", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("shoulderPads", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("chest", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("larm", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("rarm", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("armor", "0.3 0.3 0.3 1.0");
			%bot.setNodeColor("pants", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("lshoe", "0.2 0.2 0.2 1.0");
			%bot.setNodeColor("rshoe", "0.2 0.2 0.2 1.0");
			%bot.playThread(0, "headUp");
			%name = "Mounted Knight"; %score = 125;
			%mount = new AIPlayer() { attacker = 1; datablock = HorseArmor; position = "0 0 -999"; };
			%mount.setTransform(%bot.getTransform()); %mount.damageMult = 0.5; %mount.damageReduction = 20;
			if(getRandom(0, 1)) { %col = getRandom(0, 100) / 100; %mount.setNodeColor("ALL", %col SPC %col SPC %col@" 1.0");}
			else { %col = getRandom(40, 60) / 100; %mount.setNodeColor("ALL", %col SPC (%col - 0.2) SPC (%col - 0.4)@" 1.0"); }
			%bot.setTransform(vectorAdd(%bot.getPosition(), "0 0 4") SPC getWords(%bot.getTransform(), 3, 6)); %bot.setVelocity("0 0 -15");
			if(CastleDefense.idleClients <= 0)
			{ %mount.client = new AIConnection() { attacker = 1; botName = "Horse"; player = %mount; score = 0; }; $Clients++; }
			else
			{
				%cl = CastleDefense.idleClient[CastleDefense.idleClients--];
				%mount.client = %cl; %cl.attacker = 1; %cl.botName = "Horse"; %cl.player = %mount; %cl.score = 0;
			}
			CastleDefense.enemiesLeft++; CastleDefense.add(%mount); %bot.AtkKnightLoop();
		case "Wizard":
			if(CastleDefense.level <= 20) %named = 1;
			%bot.unhideNode("scoutHat");
			%bot.unhideNode("cape");
			%bot.setNodeColor("scoutHat", "0.2 0.0 0.0 1.0");
			%bot.setNodeColor("chest", "0.3 0.1 0.1 1.0");
			%bot.setNodeColor("larm", "0.2 0.0 0.0 1.0");
			%bot.setNodeColor("rarm", "0.2 0.0 0.0 1.0");
			%bot.setNodeColor("cape", "0.0 0.0 0.0 1.0");
			%bot.setNodeColor("pants", "0.1 0.0 0.0 1.0");
			%bot.setNodeColor("lshoe", "0.1 0.1 0.1 1.0");
			%bot.setNodeColor("rshoe", "0.1 0.1 0.1 1.0");
			%bot.playThread(0, "headUp");
			%name = "Wizard"; %score = 200;
		default: %bot.delete(); return;
	}
	if(CastleDefense.idleClients <= 0)
	{ %bot.client = new ScriptObject() { class = "AIConnectionSO"; alwaysNamed = !!%named; attacker = 1; botName = %name; player = %bot; score = %score; }; $Clients++; }
	else
	{
		%cl = CastleDefense.idleClient[CastleDefense.idleClients--];
		%bot.client = %cl; %cl.alwaysNamed = !!%named; %cl.botName = %name; %cl.player = %bot;
		%cl.attacker = 1; %cl.score = %score; %cl.unreducable = !!%unreducable;
	}
	CastleDefense.add(%bot);
	CastleDefense.updateAll();
	return %bot;
}

function dequeueAttacker()
{
	cancel(CastleDefense.dequeueLoop);
	%count = CastleDefense.getCount();
	for(%i=0;%i<%count;%i++)
	{
		%obj = CastleDefense.getObject(%i);
		if((%obj.getType() & $Typemasks::PlayerObjectType) && %obj.attacker)
			%spawnedBots++;
	}
	if(%spawnedBots < 60)
	{
		CastleDefense.queued--;
		%data = CastleDefense.queue0;
		for(%i=0;%i<CastleDefense.queued;%i++)
			CastleDefense.queue[%i] = CastleDefense.queue[%i + 1];
		createAttacker(getField(%data, 0), getField(%data, 1));
	}
	if(CastleDefense.queued > 0)
		CastleDefense.dequeueLoop = schedule(16, 0, "dequeueAttacker");
}

function horde()
{
	for(%i=0;%i<50;%i++)
	{
		%pos = ""; while(vectorDist(%pos, "0 0") <= 60)
			%pos = getRandom(-100, 100) SPC getRandom(-100, 100);
		createAttacker(%pos@" 2.025", (getRandom(0,4)?"Basic":"Archer"));
	}
}

if(isFile("config/server/CastleDefense.cs"))
	exec("config/server/CastleDefense.cs");

if(!isObject(EmptyShape)) datablock StaticShapeData(EmptyShape) { shapeFile = "base/data/shapes/empty.dts";};
exec("./Bot AI.cs");
exec("./Builder.cs");
exec("./Datablocks.cs");
exec("./GravProj.cs");
exec("./Misc.cs");
exec("./NumToWord.cs");
exec("./Spells.cs");
exec("./Waves.cs");
